#############################################################
# SYMBIO version 1.7                                        #
#############################################################
# Read the README file for installation instructions        #
# Visit http://symbio.sourceforge.net/ for more information #
# Released under the GNU GPL                                #
#############################################################

&symbio();

&require_module('LWP', 5.64, 'enable the TrackBack client');

my ($browser, %pinged);

if ($ENV{'REQUEST_METHOD'} eq 'POST') {
	my $url;
	if (!defined ($url = &cgiparam('url'))) {
		&header(q~Invalid *URL*~, 1);
		print '<p>The URL to the article is required.</p>';
		&footer();
	}
	else {
		my $title = &cgiparam('title');
		my $blogname = &cgiparam('blog_name');

		my (@urls, $excerpt);
		if (&cgiparam('auto')) {
			my $source = &cgiparam('source');
			while ($source =~ m#http://[^\s"']+#sig) {
				push @urls, [ decode_entities($&), 1 ];
			}
			($excerpt = $source) =~ s{<.*?>}{
				($& =~ m#^<\s*(br|img|embed|applet|object)[\s>]#i ? ' ' : '');
			}esg;
		}
		else {
			foreach my $num (1..3) {
				if (my $tburl = &cgiparam("tburl$num")) {
					push @urls, [ $tburl, &cgiparam("auto$num") ];
				}
			}
			$excerpt = &cgiparam('excerpt');
		}

		if (!@urls) {
			&header(q~URLs *Required*~, 1);
			print '<p>'
				. (&cgiparam('auto')
					? 'No URLs could be detected in the source code you entered.'
					: 'Please enter at least one URL for TrackBack or TrackBack Auto-Discovery.')
				. '</p>';
			&footer();
		}
		else {
			&header(q~Pinging *URLs*~, 1);
			print "<p>The TrackBack URLs are now being pinged...</p>\n";
			my $break;
			foreach my $info (@urls) {
				my $u = encode_entities($info->[0]);
				print "$break<fieldset>\n<legend>$u</legend>\n";
				&ping_trackback_url($url, $blogname, $title, $excerpt, $info->[0], $info->[1]);
				print "</fieldset>\n";
				$break = "<br>\n" unless ($break);
			}
			print <<END;
<p>Symbio has finished pinging the TrackBack URLs. <a
href="$ENV{'SCRIPT_NAME'}?component=$component">Click here</a>
to ping more URLs.</p>
END
			&footer();
		}
	}
}
else {
	&header(q~TrackBack *Client*~, 1);

	my $title = encode_entities($SETUP{'title'});

	print <<END;
<p>Symbio's integrated TrackBack Client allows you to ping TrackBack URLs, to
notify the author of the associated material of the fact that you published
related content. If you want to allow other authors to do the same, just enable
TrackBack in the Configuration component and TrackBack URLs will show up in all
comment windows.</p>
END

	(my $aurl = $SETUP{'articleurl'}) =~ s/<!id>//ig;
	$aurl = encode_entities($aurl);

	if (!&cgiparam('extended')) {
		print <<END;
<form method="POST" action="$ENV{'SCRIPT_NAME'}"
onsubmit="return confirm('Are you sure you want to attempt to ping all TrackBack URLs related to this content?');">
<input type="hidden" name="component" value="$component">
<input type="hidden" name="auto" value="1">
<fieldset>
<legend>Standard TrackBack Interface</legend>
<table border="0" cellpadding="0" cellspacing="0" width="100%">

<tr><td nowrap>Site Title:&nbsp;</td>
<td width="100%" nowrap><input type="text" size="76" 
style="width: 100%" name="blog_name" value="$title"></td></tr>

<tr><td nowrap>Article Title:&nbsp;</td>
<td nowrap><input type="text" size="76" 
style="width: 100%" name="title" value=""></td></tr>

<tr><td nowrap>Article URL:&nbsp;</td>
<td nowrap><input type="text" size="76" 
style="width: 100%" name="url" value="$aurl"></td></tr>

<tr><td colspan="2">HTML Source Code:</td></tr>
<tr><td colspan="2"><textarea name="source" cols="64" rows="8" class="tt"
style="width: 100%"></textarea></td></tr>

</table>

<br>

<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr><td valign="bottom"><a
href="$ENV{'SCRIPT_NAME'}?component=$component&amp;extended=1">
Extended Interface</a></td>
<td valign="bottom" align="right"><input type="submit"
value="Ping TrackBack URLs"></td></tr></table>
</fieldset>
</form>

<p>This is the basic version of the TrackBack Client. If you are using this
component for the first time, or you want a less automated version, please <a
href="$ENV{'SCRIPT_NAME'}?component=$component&amp;extended=1">click here</a>
for the Extended Interface and a brief explanation.</p>
END
	}
	else {
		print <<END;
<p>There are two ways to use this component. In both cases, you can enter the
title of your site and the article you published, and the (preferably direct)
URL to it; only the URL is required.</p>

<ul>
	<li><p>With the version that is currently displayed, you enter an excerpt
	from your publication as well as the URLs it links to. Those URLs need to
	support TrackBack Auto-Discovery, so Symbio can scout their source code for
	the TrackBack URLs it needs to ping; if not, you can enter the direct
	TrackBack URL and uncheck the Auto-Discovery checkbox.</p></li>
	<li><p>With the <a
	href="$ENV{'SCRIPT_NAME'}?component=$component">Standard Interface</a>,
	you enter the HTML source of your publication. Symbio will automagically
	extract the URLs you refer to and attempt to ping them using TrackBack
	Auto-Discovery; in addition, it will use the start of the article as the
	excerpt. Note that this one is more error-prone.</p></li>
</ul>

<script type="text/javascript"><!--
function trimExcerpt () {
	var f = document.forms[0].excerpt;
	if (f.value.length > 255)
		f.value = f.value.substring(0, 255);
}
//--></script>

<form method="POST" action="$ENV{'SCRIPT_NAME'}"
onsubmit="return confirm('Are you sure you want to ping the TrackBack URL with the information you entered?');">
<input type="hidden" name="component" value="$component">
<fieldset>
<legend>Extended TrackBack Interface</legend>
<table border="0" cellpadding="0" cellspacing="0" width="100%">

<tr><td nowrap>Site Title:&nbsp;</td>
<td colspan="2" width="100%" nowrap><input type="text" size="76" 
style="width: 100%" name="blog_name" value="$title"></td></tr>

<tr><td nowrap>Article Title:&nbsp;</td>
<td colspan="2" nowrap><input type="text" size="76" 
style="width: 100%" name="title" value=""></td></tr>

<tr><td nowrap>Article URL:&nbsp;</td>
<td colspan="2" nowrap><input type="text" size="76" 
style="width: 100%" name="url" value="$aurl"></td></tr>

<tr><td colspan="3">Article Excerpt (255 characters max.):</td></tr>
<tr><td colspan="3"><textarea name="excerpt" cols="64" rows="5" class="tt"
style="width: 100%" onkeypress="trimExcerpt();" onfocus="trimExcerpt();"
onblur="trimExcerpt();"></textarea></td></tr>

<tr><td colspan="3">TrackBack URLs To Ping:</td></tr>

<tr><td nowrap>URL 1:&nbsp;</td>
<td width="100%"><input type="text" size="76" 
style="width: 100%" name="tburl1" value=""></td>
<td nowrap>&nbsp;<input type="checkbox" name="auto1" value="1" id="t1"
class="borderless" checked> <label for="t1">Auto-Discover</label></td></tr>

<tr><td nowrap>URL 2:&nbsp;</td>
<td><input type="text" size="76" 
style="width: 100%" name="tburl2" value=""></td>
<td nowrap>&nbsp;<input type="checkbox" name="auto2" value="1" id="t2"
class="borderless" checked> <label for="t2">Auto-Discover</label></td></tr>

<tr><td nowrap>URL 3:&nbsp;</td>
<td><input type="text" size="76" 
style="width: 100%" name="tburl3" value=""></td>
<td nowrap>&nbsp;<input type="checkbox" name="auto3" value="1" id="t3"
class="borderless" checked> <label for="t3">Auto-Discover</label></td></tr>

</table>

<br>

<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr><td valign="bottom"><a
href="$ENV{'SCRIPT_NAME'}?component=$component">
Standard Interface</a></td>
<td valign="bottom" align="right"><input type="submit"
value="Ping TrackBack URLs"></td></tr></table>
</fieldset>
</form>
END
	}
	&footer();
}

sub autodiscover_trackback_url {
	my $url = shift;
	
	&init_browser();

	my $tburl;

	print '<p>Attempting to perform Auto-Discovery on URL...<br>';

	my $response = $browser->get($url);
	if ($response->is_success()) {
		my $ct = $response->content_type();
		if ($ct eq 'text/html' || $ct eq 'text/xml') {
			my $rdf;
			my $ue = quotemeta($url);
			$response->content() =~ m#<rdf:RDF\s[^>]*>.*?(<rdf:Description\s[^>]*\s+dc:identifier="$ue"[^>]+/>).*?</rdf:RDF>#s
				and $rdf = $1;
			# because trackback:ping can either be before dc:identifier or after it
			if (defined $rdf) {
				# rdf:about is deprecated so we're not going to support it
				$rdf =~ m#\strackback:ping="([^"]+)"#
					and $tburl = decode_entities($1);
				unless (defined $tburl) {
					print 'No <tt>trackback:ping</tt> or <tt>rdf:about</tt> attribute was found in the RDF data associated with the URL.';
				}
			}
			else {
				print 'No matching RDF data was found at the given URL.';
			}
		}
		else {
			print "The returned content was of the type <tt>$ct</tt>; Symbio only parses HTML and XML data.";
		}
	}
	else {
		my $status = encode_entities($response->status_line());
		print <<END;
The URL could not be retrieved for Auto-Discovery. Perhaps there was
a connection problem, or the URL no longer exists. The returned status was
<b>$status</b>.
END
	}

	if (defined $tburl) {
		my $u = encode_entities($tburl);
		print qq~The TrackBack URL is <a href="$u" target="_blank">$u</a>.~;
		return $tburl;
	}

	print '</p>';
	
	return undef;
}

sub ping_trackback_url {
	my ($url, $blogname, $title, $excerpt, $loc, $autodiscover) = @_;

	&init_browser();

	my $tburl;
	if ($autodiscover) {
		$tburl = &autodiscover_trackback_url($loc);
		return unless (defined $tburl);
	}
	else {
		$tburl = $loc;
	}

	if ($pinged{$tburl}) {
		print '<p>This TrackBack URL has already been pinged.</p>';
		return;
	}
	
	$pinged{$tburl} = 1;

	$excerpt =~ s/^\s+//;
	$excerpt =~ s/\s+$//;
	$excerpt =~ s/\s{2,}/ /g;

	my $response = $browser->post(
		$tburl,
		[
			'url' => $url,
			'title' => $title,
			'excerpt' => (length($excerpt) > 255
				? substr($excerpt, 0, 252) . '...'
				: $excerpt),
			'blog_name' => $blogname
		]
	);
	if (!$response->is_success()) {
		my $status = encode_entities($response->status_line());
		print <<END;
<p>The TrackBack URL could not be pinged. Perhaps there was a connection
problem, or the URL no longer exists. The returned status was
<b>$status</b>.</p>
END
	}
	else {
		my $content = $response->content();
		my $errorcode;
		$content =~ m#<error>(.*?)</error>#s and $errorcode = $1;
		if (defined($errorcode)) {
			if ($errorcode != 0) {
				my $msg;
				$content =~ m#<message>(.*?)</message>#s and $msg = $1;
				print <<END;
<p>The TrackBack URL returned <b>$errorcode</b> as the error code.
The explanation given was <b>$msg</b>.</p>
END
			}
			else {
				print <<END;
<p>The TrackBack URL was successfully pinged! If the web site allows it, you
will find an XML version of the list of pings for the URL, including the one
you just submitted, at <a target="_blank"
href="$tburl?__mode=rss">this location</a>.</p>
END
			}
		}
		else {
			$content = encode_entities($content);
			print <<END;
<p>The TrackBack URL returned a response that Symbio could not understand. The
response was:</p>
<pre>$content</pre>
END
		}
	}
}

sub init_browser {
	return if (defined $browser);
	$browser = new LWP::UserAgent();
	$browser->agent("TrackBack/1.1 (Symbio $symbioversion <http://symbio.sourceforge.net/>)");
	$browser->timeout(15);
	$browser->env_proxy();
}